routes/web.php
<?php

Route::get('/', 'FrontpageController@index')->name('products');

Route::resource('/cart', 'CartController');
Route::post('/cart/delete-all', 'CartController@deleteAll')->name('cart.delete.all');

Route::get('/order/checkout', 'OrderController@checkout')->name('checkout');
Route::get('/payment/process', 'OrderController@paymentProcess')->name('payment.process');
Route::post('/shippinginfo/store', 'OrderController@shippinginfoStore')->name('shippinginfo.store');
Route::post('/order/store', 'OrderController@store')->name('order.store');

Route::post('payment/stripe', 'OrderController@postPaymentWithStripe')->name('payment.stripe');


Auth::routes();

// SOCIALITE
Route::get('login/github', 'Auth\LoginController@redirectToProvider')->name('github.login');
Route::get('login/github/callback', 'Auth\LoginController@handleProviderCallback');


// ADMIN
Route::prefix('admin')->middleware(['auth', 'admin'])->group(function () {

    Route::get('/', 'AdminController@admin')->name('admin');
    Route::put('/paymentstatusupdate/{orderid}', 'AdminController@paymentStatusUpdate')->name('admin.paymentstatusupdate');
    
    Route::get('/order/notification', 'OrderController@orderNotification')->name('order.notifications');
    Route::get('/order/read/{notificationid}', 'OrderController@readSingleNotification')->name('read.single.notifications');

    Route::resource('category', 'CategoryController');
    Route::resource('product', 'ProductController');
});

// USER
Route::get('/home', 'HomeController@index')->name('home');
Route::get('/home/shipping-info', 'HomeController@shippingInfo')->name('home.shippinginfo');
Route::get('/home/orderdetails/{orderid}', 'HomeController@orderDetails')->name('home.orderdetails');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    protected $fillable = [
    	'name',
		'slug',
		'price',
		'image',
		'category_id',
		'description'
	];
	
	public function category()
	{
		return $this->belongsTo(Category::class);
	}
}

app/Http/Controllers/API/ProductController.php
<?php

namespace App\Http\Controllers\API;

use App\Product;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Http\Requests\ProductRequest;
use App\Http\Resources\ProductCollection;
use App\Http\Resources\Product as ProductResource;

class ProductController extends Controller
{
    
    public function __construct()
    {
        $this->middleware(['auth:api','admin:api'])->except('index','show');
    }
    

    public function index()
    {
        return ProductCollection::collection(Product::paginate());
    }


    public function store(ProductRequest $request)
    {
        $product = new Product();
        $product->name        = $request->name;
        $product->slug        = str_slug($request->name);
        $product->price       = $request->price;
        $product->image       = $request->image;
        $product->category_id = $request->category_id;
        $product->description = $request->description;
        $product->save();

        return response([
            'message' => 'Product created successfully.'
        ],201);
    }


    public function show($id)
    {
        return new ProductResource(Product::find($id));
    }


    public function update(Request $request, $id)
    {
        $product = Product::findOrFail($id);
        $product->update($request->all());

        return response([
            'message' => 'Product updated successfully.'
        ],201);
    }


    public function destroy($id)
    {
        $product = Product::findOrFail($id);
        $product->delete();

        return response([
            'message' => 'Product deleted successfully.'
        ],204);
    }
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Product;
use App\Category;
use Illuminate\Http\Request;

class ProductController extends Controller
{

    public function index()
    {
        $products = Product::with('category')->get(); 

        return view('admin.products.index', compact('products'));
    }


    public function create()
    {
        $categories = Category::get();

        return view('admin.products.create', compact('categories'));
    }


    public function store(Request $request)
    {
        $request->validate([
            'name'          => 'required|min:3|max:255|unique:products',
            'price'         => 'required',
            'image'         => 'required|image',
            'category_id'   => 'required|numeric',
            'description'   => 'required'
        ]);

        $name = $request->name;
        $slug = str_slug($name);

        if ($request->hasFile('image')) {
            $imageName = 'product-'.time().uniqid().'.'.$request->image->getClientOriginalExtension();
            $request->image->move(public_path('images'), $imageName);
        }

        Product::create([
            'name'          => $name,
            'slug'          => $slug,
            'image'         => $imageName,
            'price'         => $request->price,
            'category_id'   => $request->category_id,
            'description'   => $request->description
        ]);

        return redirect()->route('product.index');
    }


    public function show($id)
    {
        //
    }


    public function edit($id)
    {
        $product    = Product::findOrFail($id);
        $categories = Category::get();

        return view('admin.products.edit', compact('product','categories'));
    }


    public function update(Request $request, $id)
    {
        $request->validate([
            'name'          => 'required|min:3|max:255',
            'price'         => 'required',
            'image'         => 'image',
            'category_id'   => 'required|numeric',
            'description'   => 'required'
        ]);

        $name = $request->name;
        $slug = str_slug($name);

        $product = Product::findOrFail($id);

        if ($request->hasFile('image')) {
            if(file_exists(public_path('images/') . $product->image)){
                unlink(public_path('images/') . $product->image);
            }
            $imageName = 'product-'.time().uniqid().'.'.$request->image->getClientOriginalExtension();
            $request->image->move(public_path('images'), $imageName);
        }else{
            $imageName = $product->image;
        }

        $product->update([
            'name'          => $name,
            'slug'          => $slug,
            'image'         => $imageName,
            'price'         => $request->price,
            'category_id'   => $request->category_id,
            'description'   => $request->description
        ]);

        return redirect()->route('product.index');
    }


    public function destroy($id)
    {
        $product = Product::findOrFail($id);

        if(file_exists(public_path('images/') . $product->image)){
            unlink(public_path('images/') . $product->image);
        }

        $product->delete(); 

        return back();
    }
}

resources/views/admin/products/create.blade.php
@extends('../../layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">

        <div class="col-md-3">
            <div class="card bg-transparent text-dark rounded-0">
                <div class="card-header text-dark">Admin</div>

                <div class="card-body">
                    <ul class="list-group">
                        <li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('admin') }}" class="text-dark font-weight-bold">Dashboard</a>
                        </li>
                        <li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('category.index') }}" class="text-dark">Categories</a>
                        </li>
						<li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('product.index') }}" class="text-dark">Products</a>
                        </li>
						<li class="list-group-item bg-transparent rounded-0">
                            <a href="" class="text-dark">Settings</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="col-md-9">
            <div class="card bg-transparent text-dark rounded-0">
                <div class="card-header text-dark">Create Product</div>

                <div class="card-body">
                    <form class="" action="{{ route('product.store') }}" method="post" enctype="multipart/form-data">
                        @csrf
                        <div class="row mb-3">
                            <div class="col-md-6">
                                <label>Product name <span class="text-danger">*</span></label>
                                <input type="text" class="form-control rounded-0" name="name" required="">
                                @if ($errors->has('name'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('name') }}
                                    </div>
                                @endif
                            </div>
                            <div class="col-md-6">
                                <label>Product Price <span class="text-danger">*</span></label>
                                <input type="text" class="form-control rounded-0" name="price" required="">
                                @if ($errors->has('price'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('price') }}
                                    </div>
                                @endif
                            </div>
                        </div>
                        <div class="row mb-3">
                            <div class="col-md-6">
                                <label>Product Category <span class="text-danger">*</span></label>
                                <select name="category_id" class="form-control rounded-0">
                                    <option value="" selected disabled>--Select Category--</option>
                                    @foreach ($categories as $category)
                                        <option value="{{ $category->id }}">{{ $category->name }}</option>
                                    @endforeach
                                </select>
                                @if ($errors->has('category_id'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('category_id') }}
                                    </div>
                                @endif
                            </div>
                            <div class="col-md-6">
                                <label>Product Image <span class="text-danger">*</span></label>
                                <input type="file" class="form-control rounded-0" name="image">
                                @if ($errors->has('image'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('image') }}
                                    </div>
                                @endif
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <label>Product Description <span class="text-danger">*</span></label>
                                <textarea name="description" class="form-control rounded-0" rows="6"></textarea>
                            </div>
                        </div>
                        <button class="btn btn-primary mt-3 rounded-0" type="submit">Create Product</button>
                    </form>
                </div>

            </div>
        </div>

    </div>
</div>
@endsection

resources/views/admin/products/edit.blade.php
@extends('../../layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">

        <div class="col-md-3">
            <div class="card bg-transparent text-dark rounded-0">
                <div class="card-header text-dark">Admin</div>

                <div class="card-body">
                    <ul class="list-group">
                        <li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('admin') }}" class="text-dark font-weight-bold">Dashboard</a>
                        </li>
                        <li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('category.index') }}" class="text-dark">Categories</a>
                        </li>
						<li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('product.index') }}" class="text-dark">Products</a>
                        </li>
						<li class="list-group-item bg-transparent rounded-0">
                            <a href="" class="text-dark">Settings</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="col-md-9">
            <div class="card bg-transparent text-dark rounded-0">
                <div class="card-header text-dark">
                    Update Product
                    <a href="{{ route('product.index') }}" class="float-right btn btn-sm btn-dark rounded-0">Back</a>
                </div>

                <div class="card-body">
                    <form class="" action="{{ route('product.update',$product->id) }}" method="post" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="row mb-3">
                            <div class="col-md-6">
                                <label>Product name <span class="text-danger">*</span></label>
                                <input type="text" class="form-control rounded-0" name="name" value="{{ $product->name }}" required="">
                                @if ($errors->has('name'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('name') }}
                                    </div>
                                @endif
                            </div>
                            <div class="col-md-6">
                                <label>Product Price <span class="text-danger">*</span></label>
                                <input type="text" class="form-control rounded-0" name="price" value="{{ $product->price }}" required="">
                                @if ($errors->has('price'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('price') }}
                                    </div>
                                @endif
                            </div>
                        </div>
                        <div class="row mb-3">
                            <div class="col-md-6">
                                <label>Product Category <span class="text-danger">*</span></label>
                                <select name="category_id" class="form-control rounded-0">
                                    <option value="" selected disabled>--Select Category--</option>
                                    @foreach ($categories as $category)
                                        <option value="{{ $category->id }}" @if($product->category_id==$category->id){{'selected'}}@endif>{{ $category->name }}</option>
                                    @endforeach
                                </select>
                                @if ($errors->has('category_id'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('category_id') }}
                                    </div>
                                @endif
                            </div>
                            <div class="col-md-4">
                                <label>Product Image</label>
                                <input type="file" class="form-control rounded-0" name="image">
                                @if ($errors->has('image'))
                                    <div class="invalid-feedback d-block">
                                        {{ $errors->first('image') }}
                                    </div>
                                @endif
                            </div>
                            <div class="col-md-2">
                                @if ($product->image)
                                    <img src="{{ asset('images').'/'.$product->image }}" class="w-100 border p-2">
                                @endif
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <label>Product Description <span class="text-danger">*</span></label>
                                <textarea name="description" class="form-control rounded-0" rows="6">{{ $product->description }}</textarea>
                            </div>
                        </div>
                        <button class="btn btn-primary mt-3 rounded-0" type="submit">Update Product</button>
                    </form>
                </div>

            </div>
        </div>

    </div>
</div>
@endsection

resources/views/admin/products/index.blade.php
@extends('../../layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">

        <div class="col-md-3">
            <div class="card bg-transparent text-dark rounded-0">
                <div class="card-header text-dark">Admin</div>

                <div class="card-body">
                    <ul class="list-group">
                        <li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('admin') }}" class="text-dark font-weight-bold">Dashboard</a>
                        </li>
                        <li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('category.index') }}" class="text-dark">Categories</a>
                        </li>
						<li class="list-group-item bg-transparent rounded-0">
                            <a href="{{ route('product.index') }}" class="text-dark">Products</a>
                        </li>
						<li class="list-group-item bg-transparent rounded-0">
                            <a href="" class="text-dark">Settings</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="col-md-9">
            <div class="card bg-transparent text-dark rounded-0">
                <div class="card-header text-dark">
                    Products
                    <a href="{{ route('product.create') }}" class="btn btn-sm btn-success float-right rounded-0">Add New</a>
                </div>

                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Image</th>
                                    <th>Name</th>
                                    <th>Price</th>
                                    <th>Slug</th>
                                    <th>Category</th>
                                    <th width="130px">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach($products as $product)
                                    <tr>
                                        <td>{{ $product->id }}</td>
                                        <td>
                                            <img src="{{ asset('images').'/'.$product->image }}" alt="" width="60px">
                                        </td>
                                        <td>{{ $product->name }}</td>
                                        <td>${{ $product->price }}</td>
                                        <td>{{ $product->slug }}</td>
                                        <td>{{ @$product->category->name }}</td>
                                        <td>
                                            <a href="{{ route('product.edit',$product->id) }}" class="btn btn-sm btn-primary rounded-0">Edit</a>
                                            
                                            <a href="{{ route('product.destroy',$product->id) }}" class="btn btn-sm btn-danger rounded-0"
                                                onclick="event.preventDefault();
                                                    document.getElementById('productdestroy-form-{{$product->id}}').submit();">
                                                <span>Delete</span>
                                            </a>
                                            <form id="productdestroy-form-{{$product->id}}" action="{{ route('product.destroy',$product->id) }}" method="POST" style="display: none;">
                                                @csrf
                                                @method('DELETE')
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>

            </div>
        </div>

    </div>
</div>
@endsection